#include "ControlPanel28.h"





//  public:---------------------------

ControlPanel::ControlPanel (byte address){
	_i2c_address = address;
	Wire.begin();
}


void ControlPanel::begin(){
//	Serial.println(" begin----------");
	errorCode = _send(REQ_LCD_BEGIN, NULL );
}

void ControlPanel::clear(){
//	Serial.println(" clear----------");
	errorCode = _send(REQ_LCD_CLEAR, NULL );
}

void ControlPanel::home(){
//	Serial.println(" home----------");
	errorCode = _send(REQ_LCD_HOME, NULL );
}

void ControlPanel::setCursor(byte col,byte row){
//	Serial.println(" setCursor----------");
	col++;
	row++;
	byte Data[] = { col , row , NULL };
	errorCode = _send(REQ_LCD_SETCURSOR, Data);
}
void ControlPanel::write(char Text){
//	Serial.println(" write----------");
	char Text_e[] = { Text , NULL };
	errorCode = _send(REQ_LCD_WRITE, Text_e);
}
void ControlPanel::print(char data[]){
//	Serial.println(" print----------");
	errorCode = _send(REQ_LCD_PRINT, data);
}
void ControlPanel::print(char data[],byte base){
//	Serial.println(" print BASE----------");
	char send[255];
	switch (base) {
//		case BIN:
//			sprintf( send , "%b" , data );
//			break;
		case OCT:
			sprintf( send , "%o" , data );
			break;
		case DEC:
			sprintf( send , "%d" , data );
			break;
		case HEX:
			sprintf( send , "%x" , data );
			break;
		default:
			sprintf( send , "%c" , data );
	}

	errorCode = _send(REQ_LCD_PRINT, send);
}
void ControlPanel::cursor(){
	errorCode = _send(REQ_LCD_CURSOR, 0);
}
void ControlPanel::noCursor(){
	errorCode = _send(REQ_LCD_NOCURSOR, 0);
}
void ControlPanel::blink(){
	errorCode = _send(REQ_LCD_BLINK, 0);
}
void ControlPanel::noBlink(){
	errorCode = _send(REQ_LCD_NOBLINK, 0);
}
void ControlPanel::display(){
	errorCode = _send(REQ_LCD_DISPLAY, 0);
}
void ControlPanel::noDisplay(){
	errorCode = _send(REQ_LCD_NODISPLAY, 0);
}
void ControlPanel::scrollDisplayLeft(){
	errorCode = _send(REQ_LCD_SCROLLDISPLAYLEFT, 0);
}
void ControlPanel::scrollDisplayRight(){
	errorCode = _send(REQ_LCD_SCROLLDISPLAYRIGHT, 0);
}
void ControlPanel::autoscroll(){
	errorCode = _send(REQ_LCD_AUTOSCROLL, 0);
}
void ControlPanel::noAutoscroll(){
	errorCode = _send(REQ_LCD_NOAUTOSCROLL, 0);
}
void ControlPanel::leftToRight(){
	errorCode = _send(REQ_LCD_LEFTTORIGHT, 0);
}
void ControlPanel::rightToLeft(){
	errorCode = _send(REQ_LCD_RIGHTTOLEFT, 0);
}
void ControlPanel::createChar(byte num, char Data[]){
//	Serial.println(" createChar----------");

	Wire.beginTransmission(_i2c_address);
	Wire.write(REQ_LCD_CREATECHAR);		// コマンド送信
	Wire.write(num);
	for(int i = 0 ; i <= 6 ;i++){
		Wire.write(Data[i]);
	}
	errorCode = Wire.endTransmission();
}





byte ControlPanel::keyOne(){

	errorCode = _send(REQ_KEY_ONE, 0);

	byte d = 0;
	if(errorCode == 0){
		Wire.requestFrom(_i2c_address,(uint8_t)1);
		while (Wire.available()) {
			d = Wire.read();
		}
	}
	return d;
}

byte ControlPanel::keyOrder(){

	errorCode = _send(REQ_KEY_ORDER, 0);
	
	byte d = 0;
	if(errorCode == 0){
		Wire.requestFrom(_i2c_address,(uint8_t)1);
		while (Wire.available()) {
			d = Wire.read();
		}
	}
	return d;
}

byte ControlPanel::keyOrderClear(){

	errorCode = _send(REQ_KEY_ORDER_CLEAR, 0);
	
	byte d = 0;
	if(errorCode == 0){
		Wire.requestFrom(_i2c_address,(uint8_t)1);
		while (Wire.available()) {
			d = Wire.read();
		}
	}
	return d;
}

void ControlPanel::keyAll(){	
	/////
	errorCode = _send(REQ_KEY_ALL, 0);

	int i = 0;
	if(errorCode == 0){
		Wire.requestFrom(_i2c_address , (uint8_t)(FLCP_KEY_QUANTITY + 1) );
		while (Wire.available()) {
			keyStatusAll[i] = Wire.read();
			i++;
		}
	}

}

boolean ControlPanel::keyHear(byte num){
	byte num_e[] = { num , NULL };
	errorCode = _send(REQ_KEY_HEAR, num_e);
	
	int d = 0;
	if(errorCode == 0){
		Wire.requestFrom(_i2c_address,(uint8_t)1);
		while (Wire.available()) {
			d = Wire.read();
		}
	}
	return d;
}

void ControlPanel::demo(){
//	Serial.println(" demo----------");
	char Text_e[] = FLCP_LIBRARY_VERSION;
	errorCode = _send(REQ_DEMO_MODE, Text_e);
}


//  private:---------------------------

byte ControlPanel::_send(byte Command, byte Data[]){

	Wire.beginTransmission(_i2c_address);	 
	Wire.write(Command);		// コマンド送信
	for(int i = 0 ; Data[i] != NULL ;i++){
		Wire.write(Data[i]);
	}
	return Wire.endTransmission();
}


