/////////////////////////////////////////////////////
// Sketch library for FLINT Control Panel 28
// Header file.
// Programmed by @ichirowo. http://ichirowo.com/

#pragma once

#include <Arduino.h>
#include <Wire.h>


#define FLCP_KEY_QUANTITY 28
#define FLCP_LIBRARY_VERSION "0.03"


//コマンド----------
#define REQ_LCD_BEGIN 1
#define REQ_LCD_CLEAR 2
#define REQ_LCD_HOME 3
#define REQ_LCD_SETCURSOR 4
#define REQ_LCD_WRITE 5
#define REQ_LCD_PRINT 6
#define REQ_LCD_PRINT_BASE 7
#define REQ_LCD_CURSOR 8
#define REQ_LCD_NOCURSOR 9
#define REQ_LCD_BLINK 10
#define REQ_LCD_NOBLINK 11
#define REQ_LCD_DISPLAY 12
#define REQ_LCD_NODISPLAY 13
#define REQ_LCD_SCROLLDISPLAYLEFT 14
#define REQ_LCD_SCROLLDISPLAYRIGHT 15
#define REQ_LCD_AUTOSCROLL 16
#define REQ_LCD_NOAUTOSCROLL 17
#define REQ_LCD_LEFTTORIGHT 18
#define REQ_LCD_RIGHTTOLEFT 19
#define REQ_LCD_CREATECHAR 20
#define REQ_KEY_ONE 100
#define REQ_KEY_ORDER 101
#define REQ_KEY_ORDER_CLEAR 102
#define REQ_KEY_ALL 103
#define REQ_KEY_HEAR 104

#define REQ_DEMO_MODE 255



class ControlPanel{
  public:
	ControlPanel(uint8_t);

	void begin();
	void clear();
	void home();
	void setCursor(byte, byte);
	void write(char);
	void print(char[]);
	void print(char[],byte);
	void cursor();
	void noCursor();
	void blink();
	void noBlink();
	void display();
	void noDisplay();
	void scrollDisplayLeft();
	void scrollDisplayRight();
	void autoscroll();
	void noAutoscroll();
	void leftToRight();
	void rightToLeft();
	void createChar(byte, char[]);

	byte keyOne();
	byte keyOrder();
	byte keyOrderClear();
	void keyAll();
	boolean keyHear(byte num);

	void demo();


	byte errorCode;
	boolean keyStatusAll[ FLCP_KEY_QUANTITY + 1 ];


  private:
	byte _send(byte, byte[]);


	uint8_t _i2c_address;
	
};


